import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.core.toolkit.StringPool;
import com.baomidou.mybatisplus.generator.AutoGenerator;
import com.baomidou.mybatisplus.generator.InjectionConfig;
import com.baomidou.mybatisplus.generator.config.DataSourceConfig;
import com.baomidou.mybatisplus.generator.config.FileOutConfig;
import com.baomidou.mybatisplus.generator.config.GlobalConfig;
import com.baomidou.mybatisplus.generator.config.PackageConfig;
import com.baomidou.mybatisplus.generator.config.StrategyConfig;
import com.baomidou.mybatisplus.generator.config.TemplateConfig;
import com.baomidou.mybatisplus.generator.config.po.TableInfo;
import com.baomidou.mybatisplus.generator.config.rules.DateType;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.baomidou.mybatisplus.generator.engine.FreemarkerTemplateEngine;

import java.util.ArrayList;
import java.util.List;

/**
 * @Date 2019/10/31
 * @description mybatisplus基础代码生成工具
 * 根据实际情况更改TABLE_NAME、ENTITY_NAME
 */

public class CodeGeneratorMyBatis1 {

    private static  final String dburl = "jdbc:mysql://localhost:3306/wjdit_ecosystem_db_v1.0.0?serverTimezone=Asia/Shanghai&useUnicode=true&useSSL=false&characterEncoding=utf8";
    private static final String userName = "root";
    private static final String password = "123456";
    private static  final String TABLE_NAMES ="t_analysis_green_wave_peak_detail";
    private static    String ENTITY_NAME = null;
    private static  final String AUTHOR ="fengyi";

    private static final  boolean OVERITE_FILE = true;  //是否覆盖源文件
    private static final String PARENT_PACAGE = "net.wanji";

    private static final String MODULE_NAME="opt";
    //表头标识
    private static final String TABLE_PREFIX="t_";

    static String subModulePackage = ".report";

    private static String toEntityName(String tableName) {
        if (tableName.startsWith(TABLE_PREFIX)) {
            tableName = tableName.substring(TABLE_PREFIX.length());
        }
        String[] sps = tableName.split("_");
        StringBuilder stringBuilder = new StringBuilder();
        for (String str : sps) {
            String upStr = str.substring(0,1).toUpperCase()+str.substring(1);
            stringBuilder.append(upStr);
        }
        return stringBuilder.toString();
    }

    public static void main(String[] args) {
        String[] sps = TABLE_NAMES.split(",");
        for (String tableName : sps) {
            codeGen(tableName);
        }
    }


    public static void codeGen(String tableName) {
        if (ENTITY_NAME==null)
            ENTITY_NAME = toEntityName(tableName);
        // 代码生成器
        AutoGenerator mpg = new AutoGenerator();

        // 全局配置
        GlobalConfig gc = new GlobalConfig();
        String projectPath = "./signal-optimize-service";
//        String  projectPath = "./wj-gernerator/output";

        gc.setOutputDir(projectPath+"/src/main/java");
        gc.setAuthor(AUTHOR);
        gc.setOpen(false);
        gc.setSwagger2(true); //实体属性 Swagger2 注解
        gc.setEnableCache(false);
        gc.setEntityName(ENTITY_NAME);
        gc.setControllerName(ENTITY_NAME+"Controller");
        gc.setServiceName(ENTITY_NAME+"Service");
        gc.setServiceImplName(ENTITY_NAME+"ServiceImpl");
        gc.setMapperName(ENTITY_NAME+"Mapper");
        gc.setXmlName(ENTITY_NAME+"Mapper");

        gc.setBaseResultMap(true);
        gc.setBaseColumnList(true);
        gc.setIdType(IdType.NONE);
        gc.setDateType(DateType.ONLY_DATE);
        gc.setFileOverride(OVERITE_FILE);
        mpg.setGlobalConfig(gc);
        // 数据源配置mysql
        DataSourceConfig dsc = new DataSourceConfig();
        dsc.setUrl(dburl);
        dsc.setDriverName("com.mysql.jdbc.Driver");
        dsc.setUsername(userName);
        dsc.setPassword(password);
        mpg.setDataSource(dsc);

        // 包配置
        PackageConfig pc = new PackageConfig();
        pc.setModuleName(MODULE_NAME);
        pc.setParent(PARENT_PACAGE);
        pc.setController("controllerv2"+subModulePackage);
        pc.setEntity("entity"+subModulePackage);
        pc.setMapper("dao.mapper"+subModulePackage);
        pc.setService("servicev2"+subModulePackage);
        pc.setServiceImpl("servicev2"+subModulePackage+".impl");

        mpg.setPackageInfo(pc);

        // ==================  自定义配置  =================
        InjectionConfig cfg = new InjectionConfig() {
            @Override
            public void initMap() {
                // to do nothing
            }
        };
        List<FileOutConfig> focList = new ArrayList<>();
        // 调整 xml 生成目录演示
        focList.add(new FileOutConfig("/templates/mybatis1/mapper.xml.ftl") {
            @Override
            public String outputFile(TableInfo tableInfo) {
                // 自定义输入文件名称
                return projectPath + "/src/main/resources/mapper/"+subModulePackage.substring(1)+"/"
                        + tableInfo.getEntityName() + "Mapper" + StringPool.DOT_XML;
            }
        });
        cfg.setFileOutConfigList(focList);


        mpg.setCfg(cfg);

        // 配置模板
        TemplateConfig templateConfig = new TemplateConfig();

        // 配置自定义输出模板
        //指定自定义模板路径，注意不要带上.ftl/.vm, 会根据使用的模板引擎自动识别
        templateConfig.setEntity("templates/mybatis1/entity.java");
        templateConfig.setXml("templates/mybatis1/mapper.xml");
        templateConfig.setMapper("templates/mybatis1/mapper.java");
        templateConfig.setService("templates/mybatis1/provider.java");
        templateConfig.setServiceImpl("templates/mybatis1/providerImpl.java");
        templateConfig.setController("templates/mybatis1/restServer.java");

        //使默认的xml目录不再生成,使用自定义的resource/mapper输出目录
        templateConfig.setXml(null);
        mpg.setTemplate(templateConfig);


        // 策略配置
        StrategyConfig strategy = new StrategyConfig();
        strategy.setNaming(NamingStrategy.underline_to_camel);
        strategy.setColumnNaming(NamingStrategy.underline_to_camel);
//        strategy.setSuperEntityClass("com.baomidou.ant.service.BaseEntity"); //entity父级
        strategy.setEntityLombokModel(true);
        strategy.setRestControllerStyle(true);
        // 公共父类
//        strategy.setSuperControllerClass("com.baomidou.ant.service.BaseController");
        // 写于父类中的公共字段
//        strategy.setSuperEntityColumns("id");
        strategy.setInclude(tableName); //表名，多个英文逗号分割").split(",")
        strategy.setControllerMappingHyphenStyle(true);
        strategy.setTablePrefix(TABLE_PREFIX);
        strategy.setSuperMapperClass("BaseInterfaceMapper");
        strategy.setSuperServiceClass(null);
        strategy.setSuperEntityClass("TrackableEntity");
        strategy.setSuperServiceImplClass(null);
        strategy.setFieldPrefix("t_","s_","dt_","i_","bs_");
        strategy.setTablePrefix("t_");

        mpg.setStrategy(strategy);

        mpg.setTemplateEngine(new FreemarkerTemplateEngine());

        mpg.execute();

        System.out.println("MyBatis Plus Code Generator Finished!!");
    }

}
