package ${package.Controller};

import ${package.Entity}.${entity};
import ${package.Service}.${table.serviceName};
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import com.wanji.common.framework.rest.JsonViewObject;
import com.wanji.common.framework.rest.impl.AbstractRestServerImpl;
import com.wanji.common.framework.dubbointerface.BaseDubboInterface;
import com.wanji.common.framework.exception.DubboProviderException;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.*;
import com.wanji.common.framework.rest.JsonViewObject;

<#if restControllerStyle>
<#else>
import org.springframework.stereotype.Controller;
</#if>
<#if superControllerClassPackage??>
import ${superControllerClassPackage};
</#if>

import lombok.extern.slf4j.Slf4j;
import javax.annotation.Resource;
import javax.validation.Valid;
import java.util.List;

/**
* <p>
* ${table.comment!} 前端控制器
* </p>
*
* @author ${author}
* @since ${date}
*/
@Slf4j
@Api(tags = "${table.comment!}")
<#if restControllerStyle>
@RestController
<#else>
@Controller
</#if>
@RequestMapping("<#if package.ModuleName??>/${package.ModuleName}</#if>/<#if controllerMappingHyphenStyle??>${controllerMappingHyphen}<#else>${table.entityPath}</#if>")
<#if kotlin>
class ${table.controllerName}<#if superControllerClass??> : ${superControllerClass}()</#if>
<#else>
<#if superControllerClass??>
public class ${table.controllerName} extends ${superControllerClass} {
<#else>
public class ${table.controllerName}  {
</#if>

    @Resource
    private ${table.serviceName} ${table.serviceName?uncap_first};



    @GetMapping("/list")
    @ApiOperation(httpMethod="GET",value="", notes="")
    @ApiImplicitParams({
    @ApiImplicitParam(name = "{page}", value = "页号", required = true, dataType = "String"),
    @ApiImplicitParam(name = "{size}", value = "页大小", required = true, dataType = "String")
    })
    @ApiResponses({
    @ApiResponse(code = 200, message = "成功", response = Object.class,
    responseHeaders = {@ResponseHeader(name = "Content-Type", description = "application/json")})
    })
    public JsonViewObject list(@RequestParam(defaultValue = "0") Integer page, @RequestParam(defaultValue = "10") Integer size) {
        JsonViewObject jsonViewObject = JsonViewObject.newInstance();
        try {
            List<${entity}> list = ${table.serviceName?uncap_first}.findAll();
            return jsonViewObject.success(list);
        } catch (DubboProviderException e) {
            log.error("",e);
            return jsonViewObject.fail();
        }
    }

}
</#if>